'From Squeak2.8alpha of 4 February 2000 [latest update: #2052] on 28 April 2000 at 6:55:51 pm'!
"Change Set:		011FontFixes-raa
Date:			25 April 2000
Author:			Bob Arning

Changeset 1975 seems to have introduced a few oddities in bold and italic synthesized fonts. Take a look a the largest size of NewYork in bold with some spaces in it to see what I mean. I have included a fix for the bold problem below. I'll talk about italic in my next post.

Changeset 1975 seems to have introduced some oddities in generated italic fonts. Check a string like 'T H I S  I S  I N  C O D E' in italic in the largest size of NewYork. I sweated over the code for a while and decided to try something simpler. The code below fixes the new glitch as well as the clipped upper right portions of characters. One drawback, however, is that characters are now spaced farther apart. I would appreciate hearing from anyone who cares about the appearance of large italic fonts as to whether the change is a net gain or not."!


!StrikeFont methodsFor: 'emphasis' stamp: 'RAA 4/25/2000 12:58'!
makeBoldGlyphs
	"Make a bold set of glyphs with same widths by ORing 1 bit to the right
	(requires at least 1 pixel of intercharacter space)"
	| g bonkForm |
	g _ glyphs deepCopy.
	bonkForm _ (Form extent: 1@g height) fillBlack offset: -1@0.
	self bonk: g with: bonkForm.
	g copyBits: g boundingBox from: g at: (1@0)
		clippingBox: g boundingBox rule: Form under fillColor: nil.
	glyphs _ g! !

!StrikeFont methodsFor: 'emphasis' stamp: 'RAA 4/25/2000 19:48'!
makeItalicGlyphs
	"Make an italic set of glyphs with same widths by skewing left and right
	(may require more intercharacter space)"

	| dest nextX source destRect bb rect delta shift |
	shift _ glyphs height // 6.
	dest _ Form extent: glyphs extent + ((shift * (maxAscii - minAscii + 1))@0) depth: glyphs depth.
	bb _ WarpBlt toForm: dest.
	bb colorMap: nil.
	bb combinationRule: Form over.
	nextX _ 0.
	minAscii to: maxAscii do:
		[:i |
		source _ self characterFormAt: (Character value: i).
		destRect _ nextX@0 extent: (source width + shift @ source height).
		bb sourceForm: source.
		rect _ source boundingBox innerCorners.
		rect at: 1 put: (rect at: 1) - (shift@0).
		rect at: 3 put: (rect at: 3) + (shift@0).
		bb copyQuad: rect toRect: destRect.
		nextX _ nextX + destRect width].
	glyphs _ dest.
	delta _ 0.
	xTable _ xTable copy.
	maxWidth _ maxWidth + 4.
	minAscii to: maxAscii do:
		[:i |
		delta _ delta + shift.
		xTable at: i+2 put: (xTable at: i+2) + delta]! !

